
#ifndef __DALI_TOOLKIT_TEXT_BGRA_SHADER_H__
#define __DALI_TOOLKIT_TEXT_BGRA_SHADER_H__

/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

// EXTERNAL INCLUDES
#include <dali/public-api/shader-effects/shader-effect.h>

namespace Dali
{

namespace Toolkit
{

namespace Text
{

/**
 * @brief A BGRA shader for rendering glyphs.
 */
namespace BgraShader
{

/**
 * Create a basic text shader.
 * @return A handle to a newly allocated ShaderEffect
 */
Dali::ShaderEffect New();

} // namespace BGRAShader

} // namespace Text

} // namespace Toolkit

} // namespace Dali

#endif // __DALI_TOOLKIT_TEXT_BGRA_SHADER_H__
